local a=require"nixio.fs"
local s=require"luci.ip"
local h=require"math"
local r=require"luci.util"
local e,i,o,n,t=tonumber,tostring,type,unpack,select
module"luci.cbi.datatypes"
_M['or']=function(i,...)
local e
for e=1,t('#',...),2 do
local a=t(e,...)
local t=t(e+1,...)
if o(a)~="function"then
if a==i then
return true
end
e=e-1
elseif a(i,n(t))then
return true
end
end
return false
end
_M['and']=function(i,...)
local e
for e=1,t('#',...),2 do
local a=t(e,...)
local t=t(e+1,...)
if o(a)~="function"then
if a~=i then
return false
end
e=e-1
elseif not a(i,n(t))then
return false
end
end
return true
end
function neg(e,...)
return _M['or'](e:gsub("^%s*!%s*",""),...)
end
function list(t,e,a)
if o(e)~="function"then
return false
end
local o
for t in t:gmatch("%S+")do
if not e(t,n(a))then
return false
end
end
return true
end
function bool(e)
if e=="1"or e=="yes"or e=="on"or e=="true"then
return true
elseif e=="0"or e=="no"or e=="off"or e=="false"then
return true
elseif e==""or e==nil then
return true
end
return false
end
function uinteger(t)
local e=e(t)
if e~=nil and h.floor(e)==e and e>=0 then
return true
end
return false
end
function integer(t)
local e=e(t)
if e~=nil and h.floor(e)==e then
return true
end
return false
end
function ufloat(t)
local e=e(t)
return(e~=nil and e>=0)
end
function float(t)
return(e(t)~=nil)
end
function ipaddr(e)
return ip4addr(e)or ip6addr(e)
end
function ip4addr(e)
if e then
return s.IPv4(e)and true or false
end
return false
end
function ip4prefix(t)
t=e(t)
return(t and t>=0 and t<=32)
end
function ip6addr(e)
if e then
return s.IPv6(e)and true or false
end
return false
end
function ip6prefix(t)
t=e(t)
return(t and t>=0 and t<=128)
end
function port(t)
t=e(t)
return(t and t>=0 and t<=65535)
end
function portrange(t)
local a,e=t:match("^(%d+)%-(%d+)$")
if a and e and port(a)and port(e)then
return true
else
return port(t)
end
end
function macaddr(t)
if t and t:match(
"^[a-fA-F0-9]+:[a-fA-F0-9]+:[a-fA-F0-9]+:"..
"[a-fA-F0-9]+:[a-fA-F0-9]+:[a-fA-F0-9]+$"
)then
local a=r.split(t,":")
for t=1,6 do
a[t]=e(a[t],16)
if a[t]<0 or a[t]>255 then
return false
end
end
return true
end
return false
end
function hostname(e)
if e and(#e<254)and(
e:match("^[a-zA-Z_]+$")or
(e:match("^[a-zA-Z0-9_][a-zA-Z0-9_%-%.]*[a-zA-Z0-9]$")and
e:match("[^0-9%.]"))
)then
return true
end
return false
end
function host(e)
return hostname(e)or ipaddr(e)
end
function network(e)
return uciname(e)or host(e)
end
function wpakey(e)
if#e==64 then
return(e:match("^[a-fA-F0-9]+$")~=nil)
else
return(#e>=8)and(#e<=63)
end
end
function wepkey(e)
if e:sub(1,2)=="s:"then
e=e:sub(3)
end
if(#e==10)or(#e==26)then
return(e:match("^[a-fA-F0-9]+$")~=nil)
else
return(#e==5)or(#e==13)
end
end
function string(e)
return true
end
function directory(o,e)
local t=a.stat(o)
e=e or{}
if t and not e[t.ino]then
e[t.ino]=true
if t.type=="dir"then
return true
elseif t.type=="lnk"then
return directory(a.readlink(o),e)
end
end
return false
end
function file(o,t)
local e=a.stat(o)
t=t or{}
if e and not t[e.ino]then
t[e.ino]=true
if e.type=="reg"then
return true
elseif e.type=="lnk"then
return file(a.readlink(o),t)
end
end
return false
end
function device(o,t)
local e=a.stat(o)
t=t or{}
if e and not t[e.ino]then
t[e.ino]=true
if e.type=="chr"or e.type=="blk"then
return true
elseif e.type=="lnk"then
return device(a.readlink(o),t)
end
end
return false
end
function uciname(e)
return(e:match("^[a-zA-Z0-9_]+$")~=nil)
end
function range(t,o,a)
t=e(t)
o=e(o)
a=e(a)
if t~=nil and o~=nil and a~=nil then
return((t>=o)and(t<=a))
end
return false
end
function min(t,a)
t=e(t)
a=e(a)
if t~=nil and a~=nil then
return(t>=a)
end
return false
end
function max(a,t)
a=e(a)
t=e(t)
if a~=nil and t~=nil then
return(a<=t)
end
return false
end
function rangelength(t,a,o)
t=i(t)
a=e(a)
o=e(o)
if t~=nil and a~=nil and o~=nil then
return((#t>=a)and(#t<=o))
end
return false
end
function minlength(a,t)
a=i(a)
t=e(t)
if a~=nil and t~=nil then
return(#a>=t)
end
return false
end
function maxlength(t,a)
t=i(t)
a=e(a)
if t~=nil and a~=nil then
return(#t<=a)
end
return false
end
function phonedigit(e)
return(e:match("^[0-9\*#!%.]+$")~=nil)
end
